#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
enum states { before, inside, after };
void step(enum states *state, int c)
{
    switch(*state) {
        case before:
            if(c != ' ') {
                putchar(c);
                if(c != '\n')
                    *state = inside;
            }
            break; 
        case inside:
            if(!isspace(c))
                putchar(c);
            else {
                if(c == '\n') {
                    putchar('\n');
                    *state = before;
                } else
                    *state = after;
            }
            break;
        case after:
            if(c == '\n') {
                putchar('\n');
                *state = before;
            }
        default:
	    fprintf(stderr, "unknown state %p\n", state);
	    abort();
    }
} 
int main(void)
{
    int c;
    enum states state = before;
    while((c = getchar()) != EOF) {
        step(&state, c);
    }
    return 0;
}
