#include <stdio.h>
#include <ctype.h>

typedef void (*voidfp)();    // hack around recursive definition
typedef voidfp (*statefp)(int c);

voidfp before(int c), inside(int c), after(int c);    // forward decls

voidfp before(int c) {
    if(c != ' ') {
        putchar(c);
        if(c != '\n')
            return (voidfp) inside;
    }
    return (voidfp) before;
}

voidfp inside(int c) {
    if(!isspace(c))
        putchar(c);
    else {
        if(c == '\n') {
            putchar('\n');
            return (voidfp) before;
        } else
            return (voidfp) after;
    }
    return (voidfp) inside;
}

voidfp after(int c) {
    if(c == '\n') {
        putchar('\n');
        return (voidfp) before;
    }
    return (voidfp) after;
} 

int main(void)
{
    int c;
    statefp state = before;
    while((c = getchar()) != EOF) {
        state = (statefp) (*state)(c);
    }
    return 0;
}
