#include <stdio.h>
#include <ctype.h>

typedef void (*actions)(int c);

void skip(int c), print(int c); // forward decls

typedef enum {before, inside, after, num_states} states;
typedef enum {space, newline, other, num_inputs} inputs;
typedef struct {states next; actions act;} edges;

edges lookup[num_states][num_inputs] = {
                 /* space         newline         others */
    /* before */ { {before,skip}, {before,print}, {inside,print} },
    /* inside */ { {after, skip}, {before,print}, {inside,print} },
    /* after  */ { {after, skip}, {before,print}, {after, skip} }
};


void skip(int c) {
}
void print(int c) {
    putchar(c);
}


int main(void)
{
    int c;
    states state = before;
    while((c = getchar()) != EOF) {
	inputs inp = c == ' ' ? space : c == '\n' ? newline : other;
	edges *edge = &lookup[state][inp];
	edge->act(c);
        state = edge->next;
    }
    return 0;
}
