#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
int main(void)
{
    enum states {
        before, inside, after
    } state;
    int c;
    state = before;
    while((c = getchar()) != EOF) {
        switch(state) {
            case before:
                if(c != ' ') {
                    putchar(c);
                    if(c != '\n')
                        state = inside;
                }
                break; 
            case inside:
                if(!isspace(c))
                    putchar(c);
                else if(c == '\n') {
                    putchar('\n');
                    state = before;
                } else
                    state = after;
                break;
            case after:
                if(c == '\n') {
                    putchar('\n');
                    state = before;
                }
                break;
            default:
                fprintf(stderr, "unknown state %d\n", state);
                abort();
        }
    }
    return 0;
}
